/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
#line 1 "yacc_cadtrace.y" /* yacc.c:339  */


 /***************************************************************************

Copyright 2016 J.-L. LAMOTTE

This file is part of CADTRACE.

    CADTRACE is free software: you can redistribute it and/or modify it
    under the terms of the GNU Lesser General Public License as
    published by the Free Software Foundation, either version 3 of the
    License, or (at your option) any later version.

    CADTRACE is distributed in the hope that it will be useful, but WITHOUT
    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General
    Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with CADTRACE. If not, see
    <http:#www.gnu.org/licenses/>.


**************************************************************************/


#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "desc_compilateur.h"
  
char mul_error[]   = " UNSTABLE MULTIPLICATION.";
char sign_error[]  = " INSTABILITY IN SIGN FUNCTION.";
char mod_error[]   = " INSTABILITY IN MOD FUNCTION.";
char dim_error[]   = " INSTABILITY IN DIM FUNCTION.";
char int_error[]   = " INSTABILITY IN INT FUNCTION.";
char nint_error[]  = " INSTABILITY IN NINT FUNCTION.";
char div_error[]   = " UNSTABLE DIVISION.";
char test_error[]  = " UNSTABLE BRANCHING.";
char pui_error[]   = " UNSTABLE POWER FUNCTION.";
char log_error[]   = " NEGATIVE OR NULL VALUE IN LOG FUNCTION.";
char sqrt_error[]  = " NEGATIVE OR NULL VALUE IN SQRT FUNCTION.";
char exp_error[]   = " UNSTABLE EXPONENTIAL FUNCTION.";
char log10_error[] = " NEGATIVE OR NULL VALUE IN LOG10  FUNCTION.";
char perte_error[] = " LOSS OF ACCURACY DUE TO CANCELLATION(S).";
char abs_error[]   = " INSTABILITY IN ABS FUNCTION.";
  
 extern  void yyerror(char *);


extern int yylex(void);
extern char yytext[];

extern FILE *yyin;
extern int yyparse();
extern char *fonction_connue(char*);

int NbInstabilite=0;
int YaccErreur=0;


#define MAXFONCTION 1000
#define MAXFICHIER  1000
#define MAXAPPEL 25 
#define DECALAGE 2 /* pour l'affichage */

#define DEBUGn

/* tableau des nom de fonctions rencontrees */

char *nomfonction[MAXFONCTION];
int nbfonction=0;


/* tableau des nom de fichiers rencontrees */

char *nomfichier[MAXFICHIER];
int nbfichier=0;

/* Structure pour le tableau des appels */

struct monappel {
  /* caracteristique de l'appel */
  char *nfonc;
  char *nfic;
  int numligne;
  int nbappel;

  struct monappel **tabappel;
    int maxtabappel;      /* pour realloc quand le tableau est plein */
  int numtabappel;
}; 

typedef struct monappel Appel;


Appel *courant=NULL;
Appel debut={NULL,NULL,0,-1,NULL,0,0};

void bilan_appel();
void usage(char *);
char *insertion_tab_fonction(char *);
char *insertion_tab_fichier(char *);
 void recherche_insertion_appel(char *, char *, int);

 

#line 174 "yacc_cadtrace.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "yacc_cadtrace.h".  */
#ifndef YY_YY_YACC_CADTRACE_H_INCLUDED
# define YY_YY_YACC_CADTRACE_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    FDF = 258,
    NOM_FONCTION = 259,
    NOM_FICHIER = 260,
    NUMERO_LIGNE = 261,
    DEBUT_LIGNE = 262
  };
#endif
/* Tokens.  */
#define FDF 258
#define NOM_FONCTION 259
#define NOM_FICHIER 260
#define NUMERO_LIGNE 261
#define DEBUT_LIGNE 262

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 112 "yacc_cadtrace.y" /* yacc.c:355  */

	int entier;
	char *chaine;
	void *li;

#line 234 "yacc_cadtrace.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;

int yyparse (void);

#endif /* !YY_YY_YACC_CADTRACE_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 251 "yacc_cadtrace.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  5
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   8

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  8
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  3
/* YYNRULES -- Number of rules.  */
#define YYNRULES  7
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  11

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   262

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   126,   126,   127,   132,   170,   214,   257
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "FDF", "NOM_FONCTION", "NOM_FICHIER",
  "NUMERO_LIGNE", "DEBUT_LIGNE", "$accept", "begin", "lignes", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262
};
# endif

#define YYPACT_NINF -5

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-5)))

#define YYTABLE_NINF -1

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int8 yypact[] =
{
      -3,    -1,     0,    -5,    -4,    -5,    -5,     2,     1,    -5,
      -5
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       0,     0,     0,     3,     4,     1,     2,     5,     0,     6,
       7
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int8 yypgoto[] =
{
      -5,    -5,     3
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int8 yydefgoto[] =
{
      -1,     2,     3
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_uint8 yytable[] =
{
       5,     7,     8,     4,     1,     6,    10,     1,     9
};

static const yytype_uint8 yycheck[] =
{
       0,     5,     6,     4,     7,     2,     5,     7,     6
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     7,     9,    10,     4,     0,    10,     5,     6,     6,
       5
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,     8,     9,     9,    10,    10,    10,    10
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     2,     1,     2,     3,     4,     4
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 4:
#line 133 "yacc_cadtrace.y" /* yacc.c:1646  */
    {
  char *fonctrouve=NULL;


#ifdef DEBUG
  printf("YACC : DEBUT LIGNE NOM_FONCTION  %d %s \n",(yyvsp[-1].entier), (yyvsp[0].chaine));
#endif

  /* on n'insert ps les appels  la fonction unstabiliy */
  if ((yyvsp[-1].entier)!=0){       
     /* on recherche si le nom de la fonction est deja dans 
	le tableau des fonctions */

      if ((yyvsp[-1].entier)==1){ 
      
	fonctrouve=fonction_connue((yyvsp[0].chaine));      
#ifdef DEBUG
	printf("YACC : NOM_FONCTION RECONNUE  <%s> :: %s \n", (yyvsp[0].chaine),fonctrouve);
#endif
	fonctrouve=insertion_tab_fonction(fonctrouve);	
	courant = &debut;
	/* on ne met pas le nom du fichier */
	recherche_insertion_appel(fonctrouve, NULL,-1);
	NbInstabilite++;
      }
      
      else {
	fonctrouve=insertion_tab_fonction((yyvsp[0].chaine));
	recherche_insertion_appel(fonctrouve, NULL, -1);
      }
#ifdef DEBUG
      printf("@@\n11\n");
#endif
  }
  free((yyvsp[0].chaine));
}
#line 1355 "yacc_cadtrace.c" /* yacc.c:1646  */
    break;

  case 5:
#line 171 "yacc_cadtrace.y" /* yacc.c:1646  */
    {

  char *fonctrouve=NULL;
  char *fichtrouve=NULL;
  
#ifdef DEBUG
  printf("YACC : DEBUT_LIGNE NOM_FONCTION NOM_FICHIER  %d %s  fichier  %d\n",
	 (yyvsp[-2].entier), (yyvsp[-1].chaine), (yyvsp[0].chaine));
#endif
  
  /* on n'insert pas les appels aux fonctions de CADNA */
  if ((yyvsp[-2].entier)!=0) {
    
    /* on recherche si le nom de la fonction est deja dans 
       le tableau des fonctions */
    fonctrouve=insertion_tab_fonction((yyvsp[-1].chaine));
    
    /* on recherche si le nom de la fonction est deja dans 
       le tableau des fonctions */
    
    
    if ((yyvsp[-2].entier)==1){ 

      fonctrouve=fonction_connue(fonctrouve);      
      
      courant = &debut;
      /* on ne met pas le nom du fichier */
      recherche_insertion_appel(fonctrouve, NULL,-1);
      NbInstabilite++;
    }
      else {
	fichtrouve=insertion_tab_fichier((yyvsp[0].chaine));
	recherche_insertion_appel(fonctrouve, fichtrouve,-1); 
      }
#ifdef DEBUG
    printf("@@\n22\n");
#endif
  }

  free((yyvsp[-1].chaine));
  free((yyvsp[0].chaine));
}
#line 1402 "yacc_cadtrace.c" /* yacc.c:1646  */
    break;

  case 6:
#line 215 "yacc_cadtrace.y" /* yacc.c:1646  */
    {

  char *fonctrouve=NULL;
  char *fichtrouve=NULL;
  
#ifdef DEBUG
  printf("YACC : DEBUT_LIGNE NOM_FONCTION NOM_FICHIER NUMERO_LIGNE %d %s  fichier %s ligne %d\n",
	 (yyvsp[-3].entier), (yyvsp[-2].chaine), (yyvsp[-1].chaine), (yyvsp[0].entier));
#endif
  
  /* on n'insert pas les appels aux fonctions de CADNA */
  if ((yyvsp[-3].entier)!=0) {
    
    /* on recherche si le nom de la fonction est deja dans 
       le tableau des fonctions */
    fonctrouve=insertion_tab_fonction((yyvsp[-2].chaine));
    
    /* on recherche si le nom de la fonction est deja dans 
       le tableau des fonctions */
    
    
    if ((yyvsp[-3].entier)==1){ 

      fonctrouve=fonction_connue(fonctrouve);      
      
      courant = &debut;
      /* on ne met pas le nom du fichier */
      recherche_insertion_appel(fonctrouve, NULL,-1);
      NbInstabilite++;
    }
      else {
	fichtrouve=insertion_tab_fichier((yyvsp[-1].chaine));
	recherche_insertion_appel(fonctrouve, fichtrouve,(yyvsp[0].entier)); 
      }
#ifdef DEBUG
    printf("@@\n33\n");
#endif
  }

  free((yyvsp[-2].chaine));
  free((yyvsp[-1].chaine));
}
#line 1449 "yacc_cadtrace.c" /* yacc.c:1646  */
    break;

  case 7:
#line 258 "yacc_cadtrace.y" /* yacc.c:1646  */
    {

  char *fonctrouve=NULL;
  char *fichtrouve=NULL;
  
#ifdef DEBUG
  printf("YACC : DEBUT_LIGNE NOM_FONCTION NUMERO_LIGNE NOM_FICHIER  %d %s  ligne %d fichier %s \n",
	 (yyvsp[-3].entier), (yyvsp[-2].chaine), (yyvsp[-1].entier), (yyvsp[0].chaine));
#endif
  
  /* on n'insert pas les appels aux fonctions de CADNA */
  if ((yyvsp[-3].entier)!=0) {
    
    /* on recherche si le nom de la fonction est deja dans 
       le tableau des fonctions */
    fonctrouve=insertion_tab_fonction((yyvsp[-2].chaine));
    
    /* on recherche si le nom de la fonction est deja dans 
       le tableau des fonctions */
    
    
    if ((yyvsp[-3].entier)==1){ 

      fonctrouve=fonction_connue(fonctrouve);      
      
      courant = &debut;
      /* on ne met pas le nom du fichier */
      recherche_insertion_appel(fonctrouve, NULL,-1);
      NbInstabilite++;
    }
      else {
	fichtrouve=insertion_tab_fichier((yyvsp[0].chaine));
	recherche_insertion_appel(fonctrouve, fichtrouve,(yyvsp[-1].entier)); 
      }
#ifdef DEBUG
    printf("@@\n44\n");
#endif
  }

  free((yyvsp[-2].chaine));
  free((yyvsp[0].chaine));
}
#line 1496 "yacc_cadtrace.c" /* yacc.c:1646  */
    break;


#line 1500 "yacc_cadtrace.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 306 "yacc_cadtrace.y" /* yacc.c:1906  */


/********************************************************************
Principe de base : On stocke dans le tableau nomfonction tous les noms
de fonctions et dans nomfichier tous les noms de fichiers. Ceci permet 
d'eviter une explosion de la memoire pour le stockage des noms.

Ensuite on remplit l'arbre des appels. 


 ********************************************************************/
/*void analyse_arg(int, **char , **char, **char, **char, **char, *int); */



/************************************************************************

Analyse des arguments du programme

 ************************************************************************/
void usage(char *s)
{
    fprintf(stderr,"\n");
    fprintf(stderr,"usage: %s [Option] gdb.out\n",s);
    fprintf(stderr,"gdb.out is obtained by executing your program with gdb (see README file)\n");
    //    fprintf(stderr,"      : %s [Option1] [Option2] \n\n",s);

    fprintf(stderr,"Option: \n");
    fprintf(stderr,"-n number: gives the depth of the call function tree to print\n");
    fprintf(stderr,"           (default 1)\n\n");

    /*    fprintf(stderr,"Option2 \n");
    fprintf(stderr,"  \n");
    fprintf(stderr,"-a name \\\"argument\\\"  : specify  the application name and the arguments between  \\\"\n");
    fprintf(stderr,"-s FileName      : specify the filename used to save teh trace\n");*/
    fprintf(stderr,"  \n");
    exit(1);
}

void analyse_arg(int argc, char **argv, char** fichiertrace, char** appli, char** argappli,
		 char** sauvetrace, int *niv)

{
    int i;
    char opt, chaine1[256], chaine2[256];
    FILE *f;

    if (argc==1) usage(argv[0]);

    for (i = 1; i < argc; i++){

	if (argv[i][0] != '-') {
	    *fichiertrace=strdup(argv[i]);
	    continue;
	}
	if (strlen(argv[i])!=2) usage(argv[0]);
	
	opt = argv[i][1];
	
	if (!opt) usage(argv[0]);
	
	if (strchr("sna", opt)) {
	    switch (opt) {
		
	    case 'n':
		if (i+1<argc) *niv=atoi(argv[++i]);
		if (niv<0) {
		    fprintf(stderr,"Niveau d'affichage < 0\n");
		    usage(argv[0]);
		}
	      break;
	      
	    case 's':
		if (i+1<argc) *sauvetrace=strdup(argv[++i]);
		break;
		
	    case 'a':
		if (i+1<argc) *appli=strdup(argv[++i]);
		if (i+1<argc) {
		    if (argv[i+1][0]=='"')
			*argappli=strdup(argv[++i]);
		}
		break;
	    default : usage(argv[0]);
	    }
	}
    }
    
    if (*appli && *fichiertrace ){
	fprintf(stderr,"Erreur dans les arguments. Le programme ne peut pas analyser un fichier\n");
	fprintf(stderr,"de trace et un programme en meme temps\n\n");
	usage(argv[0]);
    }
    if (*sauvetrace && *fichiertrace) {
	fprintf(stderr,"Erreur dans les arguments. L'option -s est incompatible avec l'analyse d'un\n");
	fprintf(stderr,"fichier de trace \n");
	usage(argv[0]);
    }

    if (*fichiertrace) {
	if ((f=fopen(*fichiertrace,"r"))==NULL){
	    fprintf(stderr,"Impossible d'ouvrir le fichier %s\n",*fichiertrace);
	    exit(1);
	}

	// test du type de trace
       	// fscanf(f,"%s %s",chaine1, chaine2);
// 	if (strcmp(chaine1,"GNU") || strcmp(chaine2,"gdb")){
// 	    fprintf(stderr,"Le fichier <%s> n'est pas une trace obtenue par gdb.\n",
// 		    *fichiertrace);
// 	    exit(1);	    
// 	}
    }
}



/********************************************************************************

Construction de l'arbre dea instabilites										 
 ********************************************************************************/


char *insertion_tab_fonction(char *f)
{
  int i;
  char *fonctrouve=NULL;

  /* on recherche si l'appel de f est deja dans le tableau des fonctions */

#ifdef DEBUG
  printf("insertion_tab_fonction :recherche insertion de <%s>\n",f);
#endif

  for(i=0;i<nbfonction;i++)
    if (!strcmp(nomfonction[i],f)) {
      fonctrouve=nomfonction[i];
      break;
    }

#ifdef DEBUG
  printf("insertion_tab_fonction : pointeur sur la fonction trouvee <%s> %p\n",f,fonctrouve);
#endif

  if (fonctrouve==NULL ){
    /* la fonction n'est pas trouvee. on l'insert dans le tableau des fonctions */

#ifdef DEBUG
  printf("insertion_tab_fonction : Fonction non trouvee recherche insertion de <%s>\n",f);
#endif

    if (nbfonction<MAXFONCTION) {
      nomfonction[nbfonction]=strdup(f);
      fonctrouve=nomfonction[nbfonction++];
    }
    else {
      fprintf(stderr,"il y a trop de fonctions pour ce programme\n"); 
      fprintf(stderr,"Appelez la maintenance\n");
      exit(1);
    }
  }
  
#ifdef DEBUG
  printf("insertion_tab_fonction :  <%s> -> %p \n",f,fonctrouve);
#endif
  return(fonctrouve);
}


char *insertion_tab_fichier(char *f)
{
  int i;
  char *fichtrouve=NULL;

  /* on recherche si l'appel de f est deja dans le tableau des fichiers */
#ifdef DEBUG
  printf("recherche insertion de %s\n",f);
#endif


  for(i=0;i<nbfichier;i++)
    if (!strcmp(nomfichier[i],f)) {
      fichtrouve=nomfichier[i];
      break;
    }

  if (fichtrouve==NULL ){
    /* la fichier n'est pas trouvee. on l'insert dans le tableau des fichiers */
    if (nbfichier<MAXFICHIER) {
      nomfichier[nbfichier]=strdup(f);
      fichtrouve=nomfichier[nbfichier++];
    }
    else {
      fprintf(stderr,"il y a trop de fichiers pour ce programme\n"); 
      fprintf(stderr,"Appelez la maintenance\n");
      exit(1);
    }
  }
  return(fichtrouve);
}

void recherche_insertion_appel(char *fo, char *fi, int li)
{
  Appel *c=courant, *appeltrouve=NULL;
  int i;

#ifdef DEBUG
  printf("recherche_insertion_appel : recherche fonction,fichier, ligne dans les appels\n");
#endif

/* on recherche si cet appel est deja reference dans les tables */
  

  for(i=0;i<c->numtabappel;i++){
#ifdef DEBUG
      printf("recherche_insertion_appel : %p %p   ---- %p %p  ---- %d %d\n",
	     c->tabappel[i]->nfonc,fo,
	     c->tabappel[i]->nfic,fi, 
	     c->tabappel[i]->numligne,li);
#endif
      if (c->tabappel[i]->nfonc==fo && 
	  c->tabappel[i]->nfic==fi  && 
	  c->tabappel[i]->numligne==li){
	  appeltrouve=c->tabappel[i];
	  break;
      }
  }
  
  
  if (appeltrouve){
#ifdef DEBUG
      printf("recherche_insertion_appel : TROUVE on ajoute 1\n",appeltrouve);
#endif
    (appeltrouve->nbappel)++;
    courant=appeltrouve;
  }
  else {
#ifdef DEBUG
      printf("recherche_insertion_appel :  NON TROUVE, insertion  nouvel element \n");
#endif  
 
   /* la fonction n'a pas ete trouvee dans les appels, on l'insert */

    if (c->numtabappel>=c->maxtabappel) {
#ifdef DEBUG
      printf("APPEL ALLOCATION du tableau \n");
#endif  	
      if ((c->tabappel=realloc(c->tabappel,sizeof(Appel *)*(c->maxtabappel+MAXAPPEL)))==NULL){	
	fprintf(stderr,"il y a trop d'appels de fonctions de base pour ce programme\n"); 
	fprintf(stderr,"Appelez la maintenance\n");
	exit(1);
      }
      c->maxtabappel+=MAXAPPEL;
    }

    if ((c->tabappel[c->numtabappel]=malloc(sizeof(Appel)))==NULL){
      fprintf(stderr,"Probleme allocation memoire 2\n"); 
      fprintf(stderr,"Appelez la maintenance\n");
      exit(1);
    }

    courant=c->tabappel[c->numtabappel];
    c->numtabappel++;
    c=courant;
    (c->nbappel)++;
    
    c->nfonc=fo;
    c->nfic=fi;
    c->nbappel=1;
    c->numligne=li;
    c->tabappel=NULL;
    c->maxtabappel=0;
    c->numtabappel=0;
  }
}



void origine_appel(char *fo, char *fi, int numlig)
{
  char *fonctrouve=NULL;
  char *fichtrouve=NULL;
  Appel *appeltrouve=NULL;
  int i;
  
  /* on recherche si l'appel de fi est deja dans le tableau des fonctions */
  fonctrouve=insertion_tab_fonction(fo);


  /* on recherche si l'appel de fo est deja dans le tableau des fichiers */
  if (fi) fichtrouve=insertion_tab_fichier(fi);

  /* on recherche si le triplet est deja dans la table des appels */
  recherche_insertion_appel(fonctrouve, fichtrouve, numlig);

}


/********************************************************************************

Affichage de l'arbre des instabilites										 
 ********************************************************************************/


void affiche(Appel* tab[], int nbelem, int e, 
	     int taillefonc, int taillefic,int niveau)
{
  int i; 
  char ch1[256], ch2[256];
  char s[]="";

/* on sort de la recursion quand nbelem==0 */

  if (e>=niveau) return; 

  if (!e) sprintf(ch1,"%%%dsThere are  %%%dd  %%%ds ",e*DECALAGE,6,taillefonc);
  else sprintf(ch1,"%%%dsout of which  %%%dd call(s) by <%%%ds> ",e*DECALAGE,6,taillefonc);
  sprintf(ch2,"file \"%%%ds\" line %%5d",taillefic);


  for(i=0;i<nbelem;i++){

    printf(ch1,s,tab[i]->nbappel, tab[i]->nfonc);
    if (tab[i]->nfic)
      printf(ch2, tab[i]->nfic,tab[i]->numligne);
    printf("\n");

    if (tab[i]->numtabappel) 
	affiche(tab[i]->tabappel,tab[i]->numtabappel,e+1,
		taillefonc,taillefic,niveau);
  }
/* pour mettre une ligne blanche apres le main() */
 if (e+1 >=niveau || !tab[i-1]->numtabappel) 
      printf("\n");
}

void bilan_appel(int niveau)
{
  int i;
  int taillenomfichier=0, taillenomfonction=0;
  

  for(i=0;i<nbfonction;i++){
    int s=strlen(nomfonction[i]);
    if (taillenomfonction<s) s=taillenomfonction;
  }

  for(i=0;i<nbfichier;i++){
    int s=strlen(nomfichier[i]);
    if (taillenomfichier<s) s=taillenomfichier;
  }

  printf("\n\nCADNA SOFTWARE --- Numerical instabilities check-up.\n");
  printf("--------------------------------------------------------\n");
  printf("\nThere are %d numerical instabilities.\n\n\n",
	 NbInstabilite);

  


  if (debut.numtabappel)
    affiche(debut.tabappel, debut.numtabappel,0,
	    taillenomfonction, taillenomfichier,niveau);
  
  if (YaccErreur){
      fprintf(stderr,"\n\nThe trace file is not readable by the tool.\n");
      exit(1);
  }

  if (!debut.numtabappel){
      fprintf(stderr,"\n\nThe trace file is empty. \n");
      exit(1);
  }


}

/********************************************************************************



 ********************************************************************************/

 void yyerror(char *s)

{
    fprintf(stderr,"ANALYSIS ERROR \n");
    fflush(stdout);
    YaccErreur =1;
}

int main(int argc, char *argv[])
{
    char *fichiertrace=NULL;
    char *appli=NULL;
    char* argappli=NULL;
    char *sauvetrace=NULL;
    int niv=1,res;
    char tmp[256];
    int traceaeffacer=0;

    analyse_arg(argc, argv, &fichiertrace, &appli, &argappli, &sauvetrace, &niv);


    if(!fichiertrace) {
	char *pos_lib;
	FILE *f;
	char *nfich_unst, *nfich_gdb, *nfich_trace;
	char nfich_unstXX[]="cad_XXXXXX", nfich_gdbXX[]="cad_XXXXXX";
	char nomfonc[256];



	nfich_unst=mktemp(nfich_unstXX);
	nfich_gdb=mktemp(nfich_gdbXX);
	
	/* on fait le nm sur la librairie */

	if ((f=fopen(nfich_gdb,"w"))==NULL){
	    fprintf(stderr,"Impossible to analyze the CADNA trace 2\n");
	    fprintf(stderr,"Problem to create a file\n");
	    exit(1);
	}
	    
#ifdef SUN
	fprintf(f,"break unstability\n");
#else
	fprintf(f,"set pagination off\n");
	fprintf(f,"break instability\n");
	fprintf(f,"set $_exitcode = -999\n");
#endif
	if (argappli) fprintf(f,"run %s\n",argappli);
	else fprintf(f,"run\n");
	fprintf(f,"while $_exitcode==-999\nwhere\ncont\nend\nquit");
	
	fclose(f);
	
	/* si l'utilisateur ne veut pas de fichier trace */

	if (sauvetrace)
	    fichiertrace=sauvetrace;
	else {
	    fichiertrace=nfich_unst;
	    traceaeffacer=1;
	}

	/* execution de gdb */

	sprintf(tmp,"gdb   -x %s %s >%s ", nfich_gdb, appli,fichiertrace);
	
	printf("Launch the program with gdb\n");
        res=system(tmp);
	if (res==-1 || res==127) {
	    fprintf(stderr,"Problem during the run.\n");
	    exit(1);
	}	

       	sprintf(tmp,"rm -f  %s",nfich_gdb);
        res=system(tmp);

	printf("Analysis of the running trace\n");

    }

    if ((yyin=fopen(fichiertrace,"r"))==NULL){
	fprintf(stderr,"Erreur ouverture fichier %s   \n", fichiertrace);
	return 0;
    }

   yyparse();
  
   /* l'utilisateur ne veut pas conserver son fichier trace */

#ifdef DEBU
      printf("FIN DE FICHIER");
#endif


   if (traceaeffacer){
       sprintf(tmp,"rm -f  %s",fichiertrace);
       res=system(tmp);
   }
   

     bilan_appel(niv+1);
   if (YaccErreur) {
       printf("\n\nAn error occurs during the run. All the instabilities are not printed\n"); 
   } 
}                 


char *fonction_connue(char *fonctrouve)
{
  
  if (strstr(fonctrouve,FONC_ADD)) fonctrouve=perte_error;
  else if (strstr(fonctrouve,FONC_SUB)) fonctrouve=perte_error;
  else if (strstr(fonctrouve,FONC_MUL)) fonctrouve=mul_error;
  else if (strstr(fonctrouve,FONC_DIV))  fonctrouve=div_error;
  else if (strstr(fonctrouve,FONC_LE)) fonctrouve=test_error;
  else if (strstr(fonctrouve,FONC_LT)) fonctrouve=test_error;
  else if (strstr(fonctrouve,FONC_GT)) fonctrouve=test_error;
  else if (strstr(fonctrouve,FONC_GE)) fonctrouve=test_error;
  else if (strstr(fonctrouve,FONC_INT)) fonctrouve=int_error;
  else if (strstr(fonctrouve,FONC_NINT)) fonctrouve=nint_error;
  else if (strstr(fonctrouve,FONC_ABS)) fonctrouve=abs_error;
  else if (strstr(fonctrouve,FONC_MAX)) fonctrouve=test_error;
  else if (strstr(fonctrouve,FONC_MIN)) fonctrouve=test_error;
  else if (strstr(fonctrouve,FONC_SIGN)) fonctrouve=sign_error;
  else if (strstr(fonctrouve,FONC_DIM)) fonctrouve=dim_error;
  else if (strstr(fonctrouve,FONC_POW)) fonctrouve=pui_error;
  else if (strstr(fonctrouve,FONC_LOG)) fonctrouve=log_error;
  else if (strstr(fonctrouve,FONC_LOG10)) fonctrouve=log10_error;
  else if (strstr(fonctrouve,FONC_SQRT)) fonctrouve=sqrt_error;
  else if (strstr(fonctrouve,FONC_EXP)) fonctrouve=exp_error;

  
  return fonctrouve;
}



